Index: issm/trunk/src/c/analyses/SmbAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/SmbAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/SmbAnalysis.cpp	(revision 26744)
@@ -46,4 +46,5 @@
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.V",SmbVEnum);
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.dswrf",SmbDswrfEnum);
+			iomodel->FetchDataToInput(inputs,elements,"md.smb.dswdiffrf",SmbDswdiffrfEnum);
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.dlwrf",SmbDlwrfEnum);
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.P",SmbPEnum);
@@ -70,8 +71,14 @@
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.Wini",SmbWiniEnum);
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.Aini",SmbAiniEnum);
+			iomodel->FetchDataToInput(inputs,elements,"md.smb.Adiffini",SmbAdiffiniEnum);
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.Tini",SmbTiniEnum);
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.Sizeini",SmbSizeiniEnum);
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.aValue",SmbAValueEnum);
+			iomodel->FetchDataToInput(inputs,elements,"md.smb.dulwrfValue",SmbDulwrfValueEnum);
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.teValue",SmbTeValueEnum);
+			iomodel->FetchDataToInput(inputs,elements,"md.smb.szaValue",SmbSzaValueEnum);
+			iomodel->FetchDataToInput(inputs,elements,"md.smb.cotValue",SmbCotValueEnum);
+			iomodel->FetchDataToInput(inputs,elements,"md.smb.ccsnowValue",SmbCcsnowValueEnum);
+			iomodel->FetchDataToInput(inputs,elements,"md.smb.cciceValue",SmbCciceValueEnum);
 			break;
 		case SMBpddEnum:
@@ -173,4 +180,7 @@
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.b_min",SmbBMinEnum);
 			break;
+		case SMBautoregressionEnum:
+         iomodel->FetchDataToInput(inputs,elements,"md.smb.basin_id",SmbBasinsIdEnum);
+         break;
 		case SMBhenningEnum:
 			iomodel->FetchDataToInput(inputs,elements,"md.smb.smbref",SmbSmbrefEnum,0.);
@@ -212,5 +222,5 @@
 	int     numoutputs;
 	char**  requestedoutputs = NULL;
-	bool    isdelta18o,ismungsm,isd18opd,issetpddfac,interp,isfirnwarming;
+	bool    isdelta18o,ismungsm,isd18opd,issetpddfac,interp,cycle,isfirnwarming;
 	int     smb_model, smbslices, averaging;
 	IssmDouble *temp = NULL;
@@ -220,18 +230,18 @@
 
 	iomodel->FindConstant(&smb_model,"md.smb.model");
-	iomodel->FindConstant(&interp,"md.timestepping.interp_forcings");
+	iomodel->FindConstant(&interp,"md.timestepping.interp_forcing");
+	iomodel->FindConstant(&cycle,"md.timestepping.cycle_forcing");
 
 	iomodel->FindConstant(&smbslices,"md.smb.steps_per_step");
 	parameters->AddObject(new IntParam(SmbStepsPerStepEnum,smbslices));
 
-
 	parameters->AddObject(iomodel->CopyConstantObject("md.smb.averaging",SmbAveragingEnum));
 
 	switch(smb_model){
 		case SMBforcingEnum:
-			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isclimatology",SmbIsclimatologyEnum));
 			break;
 		case SMBgembEnum:
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.aIdx",SmbAIdxEnum));
+			parameters->AddObject(iomodel->CopyConstantObject("md.smb.eIdx",SmbEIdxEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.swIdx",SmbSwIdxEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.denIdx",SmbDenIdxEnum));
@@ -252,9 +262,10 @@
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isdensification",SmbIsdensificationEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isturbulentflux",SmbIsturbulentfluxEnum));
-			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isclimatology",SmbIsclimatologyEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isconstrainsurfaceT",SmbIsconstrainsurfaceTEnum));
+			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isdeltaLWup",SmbIsdeltaLWupEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.InitDensityScaling",SmbInitDensityScalingEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.ThermoDeltaTScaling",SmbThermoDeltaTScalingEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.adThresh",SmbAdThreshEnum));
+			parameters->AddObject(iomodel->CopyConstantObject("md.smb.teThresh",SmbTeThreshEnum));
 			break;
 		case SMBpddEnum:
@@ -267,22 +278,22 @@
 			if(ismungsm){
 			  iomodel->FetchData(&temp,&N,&M,"md.smb.Pfac"); _assert_(N==2);
-			  parameters->AddObject(new TransientParam(SmbPfacEnum,&temp[0],&temp[M],interp,M));
+			  parameters->AddObject(new TransientParam(SmbPfacEnum,&temp[0],&temp[M],interp,cycle,M));
 			  iomodel->DeleteData(temp,"md.smb.Pfac");
 
 			  iomodel->FetchData(&temp,&N,&M,"md.smb.Tdiff"); _assert_(N==2);
-			  parameters->AddObject(new TransientParam(SmbTdiffEnum,&temp[0],&temp[M],interp,M));
+			  parameters->AddObject(new TransientParam(SmbTdiffEnum,&temp[0],&temp[M],interp,cycle,M));
 			  iomodel->DeleteData(temp,"md.smb.Tdiff");
 
 			  iomodel->FetchData(&temp,&N,&M,"md.smb.sealev"); _assert_(N==2);
-			  parameters->AddObject(new TransientParam(SmbSealevEnum,&temp[0],&temp[M],interp,M));
+			  parameters->AddObject(new TransientParam(SmbSealevEnum,&temp[0],&temp[M],interp,cycle,M));
 			  iomodel->DeleteData(temp,"md.smb.sealev");
 			}
 			if(isdelta18o){
 				iomodel->FetchData(&temp,&N,&M,"md.smb.delta18o"); _assert_(N==2);
-				parameters->AddObject(new TransientParam(SmbDelta18oEnum,&temp[0],&temp[M],interp,M));
+				parameters->AddObject(new TransientParam(SmbDelta18oEnum,&temp[0],&temp[M],interp,cycle,M));
 				iomodel->DeleteData(temp,"md.smb.delta18o");
 
 				iomodel->FetchData(&temp,&N,&M,"md.smb.delta18o_surface"); _assert_(N==2);
-				parameters->AddObject(new TransientParam(SmbDelta18oSurfaceEnum,&temp[0],&temp[M],interp,M));
+				parameters->AddObject(new TransientParam(SmbDelta18oSurfaceEnum,&temp[0],&temp[M],interp,cycle,M));
 				iomodel->DeleteData(temp,"md.smb.delta18o_surface");
 			}
@@ -304,5 +315,5 @@
 				parameters->AddObject(iomodel->CopyConstantObject("md.smb.isprecipscaled",SmbIsprecipscaledEnum));
 				iomodel->FetchData(&temp,&N,&M,"md.smb.delta18o"); _assert_(N==2);
-				parameters->AddObject(new TransientParam(SmbDelta18oEnum,&temp[0],&temp[M],interp,M));
+				parameters->AddObject(new TransientParam(SmbDelta18oEnum,&temp[0],&temp[M],interp,cycle,M));
 				iomodel->DeleteData(temp,"md.smb.delta18o");
 
@@ -371,12 +382,13 @@
 			/*Nothing to add to parameters*/
 			break;
+		case SMBautoregressionEnum:
+         /*Nothing to add to parameters*/
+         break;
 		case SMBhenningEnum:
 			/*Nothing to add to parameters*/
 			break;
 		case SMBcomponentsEnum:
-			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isclimatology",SmbIsclimatologyEnum));
 			break;
 		case SMBmeltcomponentsEnum:
-			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isclimatology",SmbIsclimatologyEnum));
 			break;
 		case SMBgradientscomponentsEnum:
@@ -385,15 +397,15 @@
 
 				iomodel->FetchData(&temp,&N,&M,"md.smb.accugrad"); _assert_(N==2);
-				parameters->AddObject(new TransientParam(SmbAccugradEnum,&temp[0],&temp[M],interp,M));
+				parameters->AddObject(new TransientParam(SmbAccugradEnum,&temp[0],&temp[M],interp,cycle,M));
 				iomodel->DeleteData(temp,"md.smb.accugrad");
 				iomodel->FetchData(&temp,&N,&M,"md.smb.runoffgrad"); _assert_(N==2);
-				parameters->AddObject(new TransientParam(SmbRunoffgradEnum,&temp[0],&temp[M],interp,M));
+				parameters->AddObject(new TransientParam(SmbRunoffgradEnum,&temp[0],&temp[M],interp,cycle,M));
 				iomodel->DeleteData(temp,"md.smb.runoffgrad");
 
 				iomodel->FetchData(&temp,&N,&M,"md.smb.accuref"); _assert_(N==2);
-				parameters->AddObject(new TransientParam(SmbAccurefEnum,&temp[0],&temp[M],interp,M));
+				parameters->AddObject(new TransientParam(SmbAccurefEnum,&temp[0],&temp[M],interp,cycle,M));
 				iomodel->DeleteData(temp,"md.smb.accuref");
 				iomodel->FetchData(&temp,&N,&M,"md.smb.runoffref"); _assert_(N==2);
-				parameters->AddObject(new TransientParam(SmbRunoffrefEnum,&temp[0],&temp[M],interp,M));
+				parameters->AddObject(new TransientParam(SmbRunoffrefEnum,&temp[0],&temp[M],interp,cycle,M));
 				iomodel->DeleteData(temp,"md.smb.runoffref");
 			break;
@@ -465,4 +477,8 @@
 			SmbGradientsElax(femmodel);
 			break;
+		case SMBautoregressionEnum:
+         if(VerboseSolution())_printf0_("    call smb autoregression module\n");
+         Smbautoregressionx(femmodel);
+         break;
 		case SMBhenningEnum:
 			if(VerboseSolution())_printf0_("  call smb Henning module\n");
@@ -497,4 +513,7 @@
 
 }/*}}}*/
+void           SmbAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* SmbAnalysis::CreateDVector(Element* element){/*{{{*/
 	_error_("not implemented");
Index: issm/trunk/src/c/analyses/SmbAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/SmbAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/SmbAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/SmoothAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/SmoothAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/SmoothAnalysis.cpp	(revision 26744)
@@ -35,4 +35,7 @@
 /*Finite Element Analysis*/
 void           SmoothAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           SmoothAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
Index: issm/trunk/src/c/analyses/SmoothAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/SmoothAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/SmoothAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
